#!/usr/bin/awk -f
# 
# Awk filter for lilo.conf to add a mosix kernel image
#
# Written by arielez@cs.huji.ac.il
# May 15, 2000
#

BEGIN { 
	label="mosix"
	image="/boot/vmlinuz.mosix"
	ignore=0

# Find root

	while( ("mount" | getline) > 0) {
		if ( $3 == "/" ) {
			root=$1
  		}
	}

# Check for root on NFS

	if ( root ~ ":/" ) {
		root="/dev/nfs"
	}

# Printing starts here
	print "default=" label
}


# Remove default line and any existing mosix image
{ 
	if ( /default=/ ) { } 
	else {
	  if ( $0 ~ "image" ) {
		if ( $0 ~ image ) { ignore=1 } else { ignore=0 ; print $0}
	  }
	  else
		if ( ignore == 0 ) { print $0 }
	}
	
}

# Print our image
END {
	print "image="image
	print "\tlabel="label
	print "\troot="root
	print "\tread-only"
}
