/*
 * Copyright (c)  1998 - 2000, Amnon Barak, The Hebrew University of Jerusalem.
 * All rights reserved.
 *
 * Permission to use, copy and distribute this software is hereby granted
 * under the terms of version 2 or any later version of the GNU General
 * Public License, as published by the Free Software Foundation.
 *
 * THE HEBREW UNIVERSITY OF JERUSALEM  PROVIDES THIS SOFTWARE IN ITS "AS IS"
 * CONDITION. THE HEBREW UNIVERSITY OF JERUSALEM DISCLAIMS  ANY LIABILITY OF
 * ANY KIND FOR ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
 */
/*
 * Author(s): Amnon Shiloh.
 */

/* THIS IS AN OPERATING-SYSTEM INDEPENDENT FILE:		*/
/* DO NOT MENTION HERE ANY STRUCTURES, VARIABLES OR DEFINITIONS	*/
/* FROM THE PARTICULAR HOSTING OPERATING-SYSTEM KERNEL		*/

/* short (inline-able) routines used by the MOSIX module */

#ifdef CONFIG_MOSIX_SEEKERNEL
#include <interfunction.h>
#else
extern struct mosix_task *curmos(void);
extern struct mosix_task *first_mosix_task(int);
extern struct mosix_task *first_mosix_runq(void);
extern void end_mosix_taskrun(void);
extern m64 get_utime(struct mosix_task *);
extern m64 get_stime(struct mosix_task *);
extern int is_a_zombie(struct mosix_task *);
extern void wake_up_mostask(struct mosix_task *);
extern void run_alone(void);
extern void free_alone(void);
extern int running_alone(void);
extern int low_level_lock(void);
extern void low_level_unlock(int);
extern void wake_daemon(struct mosix_task *);
extern int daemon_awakened(void); 
extern void use_fp_in_kernel(void);
extern void stop_using_fp_in_kernel(void);
typedef	int (*printfunc)(const char *,...);
extern printfunc printer(void), gevald(void);
#define	printf	(printer())
#ifdef IN_MOSIX_MODULE
#define	panic	(gevald())
#endif IN_MOSIX_MODULE
extern int get_pid(struct mosix_task *);
extern int I_have_interrupts(void);
extern void terminate_run(int) __attribute__ ((noreturn));
extern int number_of_free_pages(void);
extern int mkalloc(int);
extern void mkfree(void *);
extern int transfer_to_user(char *, char *, int);
extern int get_free_slots(void);
extern void zerofill(void *, int);
extern void run_kernel_task(void (*func)(void));
extern unsigned long ticks_to_ms(unsigned long);
extern unsigned long ms_to_ticks(m64);
extern int mfs_add_stats(struct mfs_stats *, struct mfs_stats *, struct mosix_task *);
#endif CONFIG_MOSIX_SEEKERNEL

#define	for_each_mosix(m)	for(m = first_mosix_task(1) ; m ; m = m->next)
#define	for_each_mosix_nolock(m) for(m = first_mosix_task(0) ; m ; m = m->next)
#define	for_mosix_runq(m)	for(m = first_mosix_runq() ; m ; m = m->next)
#define	RUNNING_ALONE	do { \
				if(!running_alone()) \
				panic("not locked %d of " __FILE__, __LINE__); \
			}while(0)
