/*
 * Copyright (c)  1998 - 2000, Amnon Barak, The Hebrew University of Jerusalem.
 * All rights reserved.
 *
 * Permission to use, copy and distribute this software is hereby granted
 * under the terms of version 2 or any later version of the GNU General
 * Public License, as published by the Free Software Foundation.
 *
 * THE HEBREW UNIVERSITY OF JERUSALEM  PROVIDES THIS SOFTWARE IN ITS "AS IS"
 * CONDITION. THE HEBREW UNIVERSITY OF JERUSALEM DISCLAIMS  ANY LIABILITY OF
 * ANY KIND FOR ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
 */
/*
 * Author(s): Amnon Shiloh, Oren Laadan.
 */

/* THIS IS AN OPERATING-SYSTEM INDEPENDENT FILE:		*/
/* DO NOT MENTION HERE ANY STRUCTURES, VARIABLES OR DEFINITIONS	*/
/* FROM THE PARTICULAR HOSTING OPERATING-SYSTEM KERNEL		*/

/* routines that are [also] used by the MOSIX module: */
/* (other shorter routines that could be made "inline" can be found in */
/* mos/interface.h, while communication routines are in mos/comm.h) */

#ifndef _MOS_MOSROUTINES_H
#define	_MOS_MOSROUTINES_H

extern int my_mosix_status(void);
extern int nth_node(int);
extern void common_daemon_setup(char *, int);
extern char *desc_mostask(struct mosix_task *);
extern now_t time_now(void);
extern now_t time_since(now_t);
extern int mos_to_net(int, void *);
#ifdef CONFIG_MOSIX_FS
extern int scan_mosix_nodes(int, int *, int *);
#endif CONFIG_MOSIX_FS
extern int remote_wait(int, void **, int *);
extern int remote_request(int, void *, int, void *, int, int, void **, int);
extern int current_free_mem(void);
extern void wait_a_little_while(void);
extern void mosix_do_add_to_whereto(struct mosix_task *, int);
extern int count_migrating_pages(void);
extern int passto(int, int);
void mem_age_and_count(void);
extern void remote_disappear(void) __attribute__((noreturn));
extern void wait_for_mosix_configuration(void);

#endif
